---
title: discord
type: input
status: experimental
categories: ["Services","Social"]
---

<!--
     THIS FILE IS AUTOGENERATED!

     To make changes please edit the contents of:
     lib/input/discord.go
-->

import Tabs from '@theme/Tabs';
import TabItem from '@theme/TabItem';

:::caution EXPERIMENTAL
This component is experimental and therefore subject to change or removal outside of major version releases.
:::
Consumes messages posted in a Discord channel.


<Tabs defaultValue="common" values={[
  { label: 'Common', value: 'common', },
  { label: 'Advanced', value: 'advanced', },
]}>

<TabItem value="common">

```yaml
# Common config fields, showing default values
input:
  label: ""
  discord:
    channel_id: ""
    bot_token: ""
    poll_period: 1m
    limit: 100
    cache: ""
```

</TabItem>
<TabItem value="advanced">

```yaml
# All config fields, showing default values
input:
  label: ""
  discord:
    channel_id: ""
    bot_token: ""
    poll_period: 1m
    limit: 100
    cache: ""
    rate_limit: ""
```

</TabItem>
</Tabs>

This input works by polling the `/channels/{channel_id}/messages` Discord API endpoint authenticated as a bot using token based authentication. The ID of the newest message consumed is stored in a cache in order to paginate results, ideally this cache should be persisted across restarts in order for the service to resume where it left off.

## Fields

### `channel_id`

A discord channel ID to consume messages from.


Type: `string`  

### `bot_token`

A bot token used for authentication.


Type: `string`  

### `poll_period`

The length of time (as a duration string) to wait between each poll for new messages. This field can be set empty, in which case requests are made at the limit set by the rate limit. This field also supports cron expressions.


Type: `string`  
Default: `"1m"`  

### `limit`

The maximum number of messages to receive in a single request.


Type: `int`  
Default: `100`  

### `cache`

A cache resource to use for request pagination.


Type: `string`  

### `rate_limit`

An optional rate limit resource to restrict API requests with.


Type: `string`  
Default: `""`  


