---
title: conditional
type: processor
status: deprecated
---

<!--
     THIS FILE IS AUTOGENERATED!

     To make changes please edit the contents of:
     lib/processor/conditional.go
-->

import Tabs from '@theme/Tabs';
import TabItem from '@theme/TabItem';

:::warning DEPRECATED
This component is deprecated and will be removed in the next major version release. Please consider moving onto [alternative components](#alternatives).
:::

Executes a set of child processors when a [condition](/docs/components/conditions/about)
passes for a message batch, otherwise a different set of processors are applied.

```yaml
# Config fields, showing default values
label: ""
conditional:
  condition:
    type: text
    text:
      arg: ""
      operator: equals_cs
      part: 0
  processors: []
  else_processors: []
```

## Alternatives

All functionality of this processor has been superseded by the
[switch](/docs/components/processors/switch) processor.

Conditional is a processor that has a list of child `processors`,
`else_processors`, and a `condition`. For each message batch, if the
condition passes, the child `processors` will be applied, otherwise
the `else_processors` are applied.

In order to conditionally process each message of a batch individually use this
processor with the [`for_each`](/docs/components/processors/for_each) processor.

## Fields

### `condition`

The [`condition`](/docs/components/conditions/about) to check against messages.


Type: `condition`  
Default: `{"text":{"arg":"","operator":"equals_cs","part":0},"type":"text"}`  

### `processors`

A list of processors to apply when the condition passes.


Type: `array`  
Default: `[]`  

### `else_processors`

A list of processors to apply when the condition does not pass.


Type: `array`  
Default: `[]`  


